// EditInstruction.cpp : implementation file
//

#include "stdafx.h"
#include "3Macs.h"
#include "EditInstruction.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditInstruction dialog


CEditInstruction::CEditInstruction(CTypedPtrList<CPtrList,CCommand*> *pp,CWnd* pParent /*=NULL*/)
	: CDialog(CEditInstruction::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditInstruction)
	//}}AFX_DATA_INIT
	list=pp;
}


void CEditInstruction::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditInstruction)
	DDX_Control(pDX, IDC_CHECK1, m_route);
	DDX_Control(pDX, IDC_COMBO1, m_list);
	DDX_Control(pDX, IDC_EDIT5, m_msg2);
	DDX_Control(pDX, IDC_EDIT4, m_msg);
	DDX_Control(pDX, IDC_EDIT3, m_reply);
	DDX_Control(pDX, IDC_EDIT2, m_comment);
	DDX_Control(pDX, IDC_EDIT1, m_header);
	DDX_Control(pDX, IDC_RADIO1, m_check1);
	DDX_Control(pDX, IDC_RADIO2, m_check2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditInstruction, CDialog)
	//{{AFX_MSG_MAP(CEditInstruction)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDABORT, OnAbort)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditInstruction message handlers
void CEditInstruction::OnOK( )
{
	CString	string;
	char	string2[256];
	int		i;
	DWORD	a,b,c,d,e;

	m_header.GetWindowText(string);
	sscanf(string,"%hX %hX %hX %hX %hX",&a,&b,&c,&d,&e);
	com->com[0]=(BYTE)a;
	com->com[1]=(BYTE)b;
	com->com[2]=(BYTE)c;
	com->com[3]=(BYTE)d;
	com->com[4]=(BYTE)e;

	com->route=m_route.GetCheck();
	m_comment.GetWindowText(com->id,64);

	m_reply.GetWindowText(string);
	sscanf(string,"%hX %hX",&a,&b);
	com->reply[0]=(BYTE)a;
	com->reply[1]=(BYTE)b;

	m_msg.GetWindowText(string);
	if (com->com[4]>0 && !string.IsEmpty())
	{
		string.MakeUpper();
		string.TrimLeft();
		string.TrimRight();
		i=0;
		while (i<com->com[4] && !string.IsEmpty())
		{
			sscanf(string,"%02hX",&a);
			com->msg2[i]=(BYTE)a;
			string=(const char*)string +2;
			string.TrimLeft();
			i++;
		}
		if (string.IsEmpty() && i<com->com[4])
		{
			sprintf(string2,"Not enough instruction message bytes (%02hX < %02hX)!",i,com->com[4]);
			AfxMessageBox(string2,MB_OK);
			return;
		}
		if (!string.IsEmpty() && i==com->com[4])
		{
			sprintf(string2,"Too many instruction message bytes!");
			AfxMessageBox(string2,MB_OK);
			return;
		}
	}

	m_msg2.GetWindowText(string);
	if (com->com[4]>0 && !string.IsEmpty())
	{
		string.MakeUpper();
		string.TrimLeft();
		string.TrimRight();
		i=0;
		while (i<com->com[4] && !string.IsEmpty())
		{
			sscanf(string,"%02hX",&a);
			com->msg[i]=(BYTE)a;
			string=(const char*)string +2;
			string.TrimLeft();
			i++;
		}
		if (string.IsEmpty() && i<com->com[4])
		{
			sprintf(string2,"Not enough instruction compare bytes (%02hX < %02hX)!",i,com->com[4]);
			AfxMessageBox(string2,MB_OK);
			return;
		}
		if (!string.IsEmpty() && i==com->com[4])
		{
			sprintf(string2,"Too many instruction compare bytes!");
			AfxMessageBox(string2,MB_OK);
			return;
		}
		com->compare=1;
	}
	else
	{
		com->compare=0;
	}
	
	com->link=m_list.GetCurSel();
	CDialog::OnOK();
}

BOOL CEditInstruction::OnInitDialog() 
{
	char	string[300];
	char	string2[20];
	DWORD	cnt,i,j,b;
	CCommand *com2;
	POSITION	pos;

	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	sprintf(string,"%02hX %02hX %02hX %02hX %02hX",com->com[0],com->com[1],com->com[2],com->com[3],com->com[4]);
	m_header.SetWindowText(string);
	sprintf(string,"%02hX %02hX",com->reply[0],com->reply[1]);
	m_reply.SetWindowText(string);
	if (com->dir==1)
		m_check1.SetCheck(1);
	else if (com->dir==0)
		m_check2.SetCheck(1);
	if (com->route)
		m_route.SetCheck(1);

	m_comment.SetWindowText(com->id);

	cnt=0;
	b=com->com[4];
	string[0]=0x00;
	while (b>0)
	{
		if (b>=8)
			j=8;
		else
			j=b;
		b-=j;
		for(i=0;i<j;i++)
		{
			sprintf(string2,"%02hX ",com->msg2[cnt]);
			cnt++;
			strcat(string,string2);
		}
		strcat(string,"\r\n");
	}
	m_msg.SetWindowText(string);

	cnt=0;
	b=com->compare?com->com[4]:0;
	string[0]=0x00;
	while (b>0)
	{
		if (b>=8)
			j=8;
		else
			j=b;
		b-=j;
		for(i=0;i<j;i++)
		{
			sprintf(string2,"%02hX ",com->msg[cnt]);
			cnt++;
			strcat(string,string2);
		}
		strcat(string,"\r\n");
	}
	m_msg2.SetWindowText(string);

	m_list.AddString("No Link");
	cnt=list->GetCount();
	pos=list->GetHeadPosition();
	for(i=0;i<cnt;i++)
	{
		com2=list->GetNext(pos);
		sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",com2->id,
				com2->com[0],com2->com[1],com2->com[2],com2->com[3],com2->com[4]);
		m_list.AddString(string);
	}
	m_list.SetCurSel(com->link);
	return TRUE;  // return TRUE unless you set the focus to a control              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditInstruction::OnRadio1() // from decoder to smartcard
{
	// TODO: Add your control notification handler code here
	com->dir=1;	
}

void CEditInstruction::OnRadio2() // from smartcard to decoder
{
	// TODO: Add your control notification handler code here
	com->dir=0;
}

void CEditInstruction::OnAbort() 
{
	EndDialog(IDABORT);
}
